/* Generated by Edge Impulse
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
// Generated on: 19.05.2021 13:57:56

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/kernels/micro_ops.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

namespace {

constexpr int kTensorArenaSize = 13200;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_RESHAPE, OP_CONV_2D, OP_MAX_POOL_2D, OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[23];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[11];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,6435 } };
const TfArray<1, float> quant0_scale = { 1, { 0.0039215688593685627, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(8) int32_t tensor_data1[2] = { -1, 400, };
const TfArray<1, int> tensor_dimension1 = { 1, { 2 } };
const ALIGN(8) int32_t tensor_data2[8] = { 8, -636, 216, 33, -112, 22, 99, -1832, };
const TfArray<1, int> tensor_dimension2 = { 1, { 8 } };
const TfArray<8, float> quant2_scale = { 8, { 0.00043138163164258003, 0.00018448811897542328, 0.00024668185506016016, 0.00033624388743191957, 0.00018102605827152729, 0.00082867225864902139, 0.00033269950654357672, 0.00020812106959056109, } };
const TfArray<8, int> quant2_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant2 = { (TfLiteFloatArray*)&quant2_scale, (TfLiteIntArray*)&quant2_zero, 0 };
const ALIGN(8) int32_t tensor_data3[16] = { -15, 0, -891, -92, -102, 30, -24, 106, 34, 15, -1, -413, 8, 36, 9, -579, };
const TfArray<1, int> tensor_dimension3 = { 1, { 16 } };
const TfArray<16, float> quant3_scale = { 16, { 0.0016455992590636015, 0.0012352339690551162, 0.0012877762783318758, 0.00093571277102455497, 0.0009033778915181756, 0.0017569587798789144, 0.0013905436499044299, 0.001086682197637856, 0.0015036560362204909, 0.0012451817747205496, 0.0020620543509721756, 0.00084205734310671687, 0.00097765063401311636, 0.0019626938737928867, 0.0030732254963368177, 0.00073046889156103134, } };
const TfArray<16, int> quant3_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant3 = { (TfLiteFloatArray*)&quant3_scale, (TfLiteIntArray*)&quant3_zero, 0 };
const ALIGN(8) int32_t tensor_data4[2] = { 1392, -1392, };
const TfArray<1, int> tensor_dimension4 = { 1, { 2 } };
const TfArray<1, float> quant4_scale = { 1, { 0.00030945241451263428, } };
const TfArray<1, int> quant4_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant4 = { (TfLiteFloatArray*)&quant4_scale, (TfLiteIntArray*)&quant4_zero, 0 };
const ALIGN(8) int8_t tensor_data5[2*400] = { 
  -20, -17, 13, -14, 14, 21, 6, 47, 37, -34, -20, 1, -8, 8, -34, -25, 4, -15, 16, 31, 17, 27, 19, 44, 5, -2, -1, -5, -16, 31, -22, 31, -31, -22, 15, -2, 29, 3, -2, 19, -18, -18, -24, -64, -20, 21, -28, -8, -50, -13, 61, -2, 32, 4, -30, 16, 34, -25, -23, 13, -15, 5, -28, -26, -48, -36, 101, -20, 32, 14, -17, 11, 28, -22, -43, -4, -16, 15, -40, 23, -16, -19, 61, 56, 35, 5, 6, 30, 50, -34, -7, -9, -6, 14, -15, -16, -2, -20, 63, 13, 25, 18, -26, 17, 29, -14, -25, 47, -18, 13, -12, -49, -8, -28, 67, 2, 7, 6, -40, 6, 11, -11, -37, -33, -11, 17, -16, 44, -23, -15, 15, 17, 10, 16, -14, 16, 30, -29, -13, -16, -30, 9, -14, 49, -41, -35, 43, 22, -6, -2, -24, 37, 21, -1, -8, -56, -19, 4, -12, -16, -50, -22, 30, 55, 11, 7, -25, 38, 3, -32, -11, -65, -15, 9, -11, -28, -35, -10, 59, 18, -13, 25, 12, 25, 3, -1, -14, -10, -24, 6, -5, -1, -25, -24, 51, -22, 31, 2, 29, 24, 27, -15, -23, 67, -6, 6, -3, -21, -51, -12, 10, 29, 8, 22, 10, 54, 22, -32, -9, -58, -4, 9, -17, 39, -23, -13, 4, -23, 33, 26, 25, 15, 13, -6, -33, -127, -19, 21, -15, 35, -41, -14, 56, 37, 9, 3, -34, 0, 1, -18, -8, 3, -24, 3, -31, -19, -33, -33, 22, 1, 18, -2, -14, 23, 23, -18, -48, 32, -14, 0, -38, -10, -8, -33, 35, 7, 35, 11, -11, 24, 56, -26, -12, -9, -11, 10, -28, -30, -4, -8, 60, 54, 6, 18, -5, 19, 10, -1, -27, 50, -16, 12, -15, -43, -32, -2, 25, 14, 10, 12, -51, 13, 38, -21, -21, -27, -20, 10, -19, -11, -17, -15, 25, 1, 18, 17, -40, -3, 29, -12, -10, 52, -7, 16, -44, 7, -30, -19, 8, 28, -6, 16, -28, 59, 23, -24, -8, 5, -21, 20, -49, 11, -27, -27, 24, 26, 7, 1, -12, 62, 8, -23, -10, -24, -12, 7, -33, -51, -41, -31, 21, 15, 21, 10, -13, 28, 18, -19, -22, 45, -7, 13, -20, 11, -31, -31, 32, -7, 4, 11, 15, 40, 5, -27, -27, -6, -14, 2, -23, -3, 
  22, 2, -15, 14, -7, -22, 2, -43, -35, 37, 20, 1, 8, -8, 31, 17, 2, 10, -7, -30, -21, -24, -23, -46, -16, -3, 15, 0, 18, -28, 24, -22, 30, 24, -14, -5, -29, -12, 8, -22, 10, 24, 27, 75, 15, -29, 34, 12, 56, 13, -56, 9, -32, -4, 27, -8, -29, 14, 32, -14, 15, -17, 29, 30, 44, 40, -104, 5, -33, -20, 24, -5, -29, 10, 37, 5, 12, -11, 33, -26, 9, 22, -52, -63, -40, -9, 4, -34, -58, 23, 6, -2, 3, -11, 17, 17, 7, 29, -51, -12, -25, -18, 37, -17, -22, 16, 25, -46, 8, -17, 14, 49, 11, 23, -66, -3, -13, -18, 40, -2, -5, 12, 39, 40, 8, -22, 20, -45, 22, 14, -12, -9, -5, -20, 13, -12, -18, 29, 21, 20, 30, -1, 14, -49, 42, 27, -37, -11, 13, -1, 23, -42, -13, 5, 16, 58, 24, -7, 18, 4, 49, 28, -21, -49, -7, -9, 25, -29, -16, 23, 20, 60, 3, -3, 23, 21, 42, 18, -59, -11, 1, -29, -4, -24, -17, 12, 14, 16, 22, -3, 0, 1, 25, 24, -58, 14, -19, -7, -28, -26, -16, 10, 25, -62, 10, -5, 4, 28, 62, 7, -3, -31, -12, -30, -9, -52, -35, 36, 6, 53, 8, -12, 11, -39, 27, 12, 3, 30, -19, -16, -23, -20, -11, 16, 31, 122, 21, -33, 24, -27, 34, 16, -51, -28, -16, -2, 24, -1, -1, 29, 12, -11, 25, -1, 34, 15, 46, 35, -11, 4, -21, 16, 21, -26, -29, 19, 35, -36, 16, -6, 47, 10, 10, 33, -47, -8, -48, -12, 19, -23, -66, 24, 17, 4, 8, -16, 28, 29, 7, 7, -57, -52, -17, -23, -1, -16, -18, 4, 42, -47, 18, -22, 14, 54, 20, 6, -26, -24, -15, -16, 64, -18, -41, 14, 27, 26, 33, -9, 4, 14, 13, 30, -27, -5, -13, -16, 30, 11, -37, 8, 8, -58, 6, -6, 33, -9, 29, 12, -11, -19, 0, -11, 26, -51, -28, 15, 17, 11, 21, -31, 42, -13, 37, 40, -19, -35, -11, -2, 8, -63, -12, 24, 17, 30, 3, -3, 40, 51, 52, 17, -23, -19, -22, -12, 16, -28, -15, 12, 20, -43, 7, -23, 33, -7, 32, 32, -25, 9, 0, 1, -16, -42, 8, 24, 30, 14, 27, 1, 25, 14, 
};
const TfArray<2, int> tensor_dimension5 = { 2, { 2,400 } };
const TfArray<1, float> quant5_scale = { 1, { 0.01532259862869978, } };
const TfArray<1, int> quant5_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant5 = { (TfLiteFloatArray*)&quant5_scale, (TfLiteIntArray*)&quant5_zero, 0 };
const ALIGN(8) int8_t tensor_data6[8*1*3*65] = { 
  /* [0][0][][] */ -14,-17,-2,4,4,7,12,-4,-39,-38,-77,-4,-38,-73,-95,-117,-79,-37,-68,-24,-7,4,7,8,3,-25,6,5,5,4,-25,-17,0,3,1,0,-7,6,10,6,-7,-28,4,-25,-4,0,-21,-7,-30,-34,-7,-14,-13,9,11,-6,8,23,21,3,15,5,31,35,17, 8,-7,2,-1,3,5,9,4,-27,5,-41,-28,-30,-61,-52,-93,-71,-37,-21,-23,22,4,-17,9,1,-3,6,-16,0,-15,3,0,0,9,3,4,2,7,-11,0,0,5,-2,-16,-7,-6,-10,-5,-26,-6,16,-25,2,-41,-7,-20,-7,3,2,13,13,9,28,26,24, -3,8,0,4,3,7,7,2,-27,-3,-38,5,-47,-15,-127,-62,-113,9,-39,-2,-7,10,0,2,2,-14,3,-5,-12,-13,-6,-9,-28,-10,0,-5,-6,-4,8,-9,12,-39,-10,-19,-1,1,11,-15,5,-28,-4,-19,-12,2,-6,0,3,5,38,-11,-7,14,16,17,17, 
  /* [1][0][][] */ -19,45,6,9,-22,-2,-15,-32,8,16,11,23,-4,53,1,13,25,-20,-85,-45,38,-6,6,5,-17,33,3,19,39,-23,0,-20,0,10,-42,28,-27,-42,13,-5,23,27,-12,-51,-64,3,1,-54,-3,2,4,43,-1,-18,11,-40,14,-37,-40,-79,-55,-77,-36,-91,-41, 12,-36,-31,-8,-1,-3,15,-17,10,-22,-4,50,9,20,35,11,-26,5,-51,-38,-19,-50,9,-3,5,-9,2,19,-7,32,-19,-15,-20,-23,-20,-7,-68,-19,-9,3,-9,-7,9,24,8,-21,-29,-2,-3,-6,4,35,32,21,-7,-55,-34,-30,-44,-28,-85,-38,-65,-94,-39, -25,-5,-44,-23,3,13,9,-8,-3,8,22,23,39,34,48,24,39,20,-56,-78,18,-16,23,27,-30,-3,11,5,0,-35,-1,20,4,7,-8,5,12,-53,11,8,-12,-2,-1,12,-25,-28,4,-26,15,-30,3,-35,-4,5,41,-31,2,-41,-37,-88,-39,-77,-57,-95,-127, 
  /* [2][0][][] */ 6,-117,-5,14,-6,17,4,18,-5,38,31,22,3,16,12,-15,-14,-10,-4,13,3,10,-4,9,6,14,-15,16,8,-12,-3,4,-3,-45,-7,-11,0,2,-8,-5,-25,3,7,-2,-6,0,2,-16,14,2,-5,7,6,14,8,-15,13,-44,-25,-34,-59,-32,-41,-8,-41, 11,-119,-10,-11,2,-12,19,13,-15,15,-1,19,8,18,-8,4,2,4,16,0,-18,10,1,13,7,13,-6,15,-5,-12,11,8,-2,-28,5,3,-10,-18,-27,-3,8,8,8,-1,-6,-26,1,-19,4,7,0,2,2,21,7,17,10,-10,-59,-41,-47,-91,-5,-16,-3, 6,-127,-11,9,-6,-13,27,0,5,41,22,12,8,24,-15,-14,-10,-3,8,-11,-9,-5,6,14,3,15,-5,15,-6,-14,0,10,9,-32,-31,-11,-13,-28,-24,2,5,7,-2,6,-16,-17,9,-7,8,7,5,-6,-2,10,2,15,-37,-55,-109,-6,113,36,108,109,88, 
  /* [3][0][][] */ -3,1,-9,2,-3,2,10,3,-4,9,-3,-4,-10,17,62,45,4,-16,4,-11,6,3,-5,1,8,18,-19,-8,-1,23,6,-17,12,11,-16,5,8,-20,-7,-31,-54,-72,-53,-75,-57,-40,-33,-67,-28,-60,-43,-5,-12,-10,8,1,7,1,11,-8,22,-13,-43,18,-31, 9,9,-8,3,8,19,10,7,-4,2,2,26,-9,17,50,41,1,-16,-4,-17,-3,21,-6,-13,12,18,11,4,19,-19,-49,-41,-15,7,-1,3,-18,-12,-3,23,-10,-76,-65,-68,-54,-39,-49,-73,-59,-68,-33,-43,-11,3,-1,-2,4,15,11,-32,-9,-7,-10,-11,-7, -6,13,-9,4,6,12,16,0,-5,-3,24,15,-9,9,57,51,5,-19,3,14,13,5,11,20,14,16,-25,-6,12,-39,-12,-41,12,2,3,-24,9,-3,-28,-20,-31,-41,-70,-127,-45,-27,-26,-42,-20,-24,-26,-70,-13,0,1,-15,-3,22,25,4,8,0,-8,6,-4, 
  /* [4][0][][] */ -20,1,-6,9,-7,7,20,-1,-5,22,18,3,-1,23,50,7,-11,-13,-5,5,-15,22,-26,-50,-27,-19,-63,-117,-122,2,3,-83,-63,0,-4,-47,-4,-57,-47,17,-32,16,-127,-116,-99,2,-32,-85,-10,17,-9,10,-19,-36,2,47,17,12,-17,20,-2,42,-24,37,-2, 16,11,0,-6,-8,21,16,4,-2,17,13,12,9,25,33,24,21,-66,18,-7,-12,-6,-29,28,50,34,17,-50,-96,-66,-37,-101,8,-17,-5,-17,-4,21,-3,-19,12,1,-76,-25,-11,-2,3,7,-5,1,11,-7,39,13,-11,16,0,3,-36,-21,28,23,-57,-41,-42, -55,7,13,-16,14,21,14,-3,-3,4,21,2,-48,22,34,27,8,-101,-30,4,1,17,1,9,-33,9,-13,10,28,24,7,-7,10,13,0,7,6,-12,2,3,0,23,16,-7,15,-3,2,-5,13,5,-8,29,33,24,12,-10,6,16,-13,-53,-5,28,-37,-44,-17, 
  /* [5][0][][] */ -1,-4,0,1,-4,-2,2,-1,0,3,-3,0,-2,1,9,-1,1,9,4,-3,4,-8,-7,6,2,3,-13,-37,-14,-19,2,10,-8,5,-3,1,4,-22,-27,-32,-88,-127,-75,-97,-43,-59,-53,-77,-98,-111,-97,-94,-101,-84,-60,-54,-41,-28,-30,-31,-31,-24,-36,-38,-18, 5,-6,1,1,-5,-6,7,0,-1,0,-1,4,3,-16,-1,2,8,3,-10,6,3,-3,-22,9,-12,-2,-14,-35,-24,5,18,-6,-9,-2,-3,6,0,-18,-25,-51,-78,-105,-110,-110,-100,-90,-86,-103,-120,-115,-107,-124,-96,-75,-64,-54,-57,-36,-39,-26,-29,-28,-55,-30,-44, -3,0,1,1,0,-7,5,0,-1,0,2,9,3,-14,5,3,0,-5,5,1,-1,7,-15,7,-13,-3,-31,-25,-34,-36,-20,1,-5,7,-6,2,2,-22,-17,-52,-104,-101,-124,-121,-99,-81,-93,-104,-110,-120,-96,-109,-95,-87,-71,-62,-41,-38,-23,-9,-15,-37,-41,-35,-34, 
  /* [6][0][][] */ -1,-4,-4,-2,-1,-1,15,-16,9,22,23,29,19,11,-42,-29,19,12,-1,17,3,0,13,10,8,2,3,1,11,5,1,-1,-3,-21,1,5,-3,5,9,-1,-6,4,2,-3,-2,0,5,6,-2,-6,-7,-3,-10,5,12,7,-7,-12,-57,-4,-44,-84,-91,-110,-94, -7,2,1,1,3,-9,-2,-26,-21,-3,31,23,7,30,-38,-40,-1,3,-4,-18,-21,-23,-6,-3,13,-4,0,-3,9,5,-6,-12,-10,0,3,9,5,-4,-15,-6,8,-4,6,2,0,-18,-22,-6,-14,3,14,-2,-9,10,2,2,3,-43,-110,-91,-63,-98,-108,-99,-115, -4,7,0,3,4,3,17,-19,-22,-2,27,9,2,17,-18,-63,23,18,-33,-19,12,-38,-4,-12,13,-10,-11,-4,14,11,-10,-8,-2,-5,-1,3,-1,-7,-8,3,2,-15,-11,-3,14,-14,-27,-8,0,15,6,-4,-32,-14,18,11,-8,-108,-119,-127,-94,-115,-105,-113,-112, 
  /* [7][0][][] */ 1,4,-67,7,5,8,13,6,-18,16,8,28,-51,22,33,48,27,10,15,-6,14,-8,-3,23,9,17,-10,13,25,13,-20,27,-23,-8,7,-3,1,2,8,4,-1,12,-8,-46,-21,-18,0,-31,11,-32,10,-53,-33,-25,-55,-32,-127,-57,-24,-109,-42,-37,-2,-35,-54, 15,-3,-14,2,6,9,28,7,-10,4,6,10,14,30,-8,17,2,22,-5,-15,4,3,7,-2,2,1,13,18,12,5,13,-14,1,-14,-2,14,3,-9,5,5,-10,-25,26,-41,-17,5,-45,-41,26,-34,21,-77,3,46,-50,-25,-42,-49,-26,-42,-26,-6,-3,-10,-18, -6,3,-34,20,-7,29,-17,-3,-54,15,13,20,-29,-4,12,17,14,12,2,10,11,15,10,17,0,21,-1,26,21,6,4,8,-7,10,0,4,-28,1,3,10,-21,16,-17,-48,-22,-14,3,-70,21,-56,-43,-87,-27,-22,-36,-67,-21,8,-18,-47,-38,-13,-44,-43,-15, 
};
const TfArray<4, int> tensor_dimension6 = { 4, { 8,1,3,65 } };
const TfArray<8, float> quant6_scale = { 8, { 0.1100023090839386, 0.047044467180967331, 0.062903866171836853, 0.085742183029651642, 0.04616164043545723, 0.21131141483783722, 0.084838367998600006, 0.053070869296789169, } };
const TfArray<8, int> quant6_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(8) int8_t tensor_data7[16*1*3*8] = { 
  /* [0][0][][] */ -127,-20,-25,-56,-35,-117,33,-9, -25,-41,-55,-40,-81,-25,10,1, -94,-17,-50,-47,-20,-19,24,-3, 
  /* [1][0][][] */ -55,-30,13,-44,-34,-29,29,-22, -50,-49,-35,-18,-4,-20,-11,-127, 84,-7,-26,-5,-1,-26,-13,-32, 
  /* [2][0][][] */ -26,-11,-11,-5,-58,38,-38,-17, -54,-17,1,1,-4,-92,-11,52, -127,-19,-3,6,-23,-13,-6,-8, 
  /* [3][0][][] */ -14,-62,-9,-7,-19,127,-11,-18, -34,-66,-1,11,-3,4,-93,-113, -75,-54,-1,-20,-24,62,4,-35, 
  /* [4][0][][] */ -99,-112,-2,-1,-39,-25,-95,-77, -94,-127,14,-16,33,-112,-53,36, -93,-108,3,-13,8,26,-40,15, 
  /* [5][0][][] */ -42,-61,-1,5,17,52,-6,-14, -91,-127,-1,14,-7,7,0,-100, -63,-101,-7,-3,24,14,-16,-14, 
  /* [6][0][][] */ 29,-33,-76,8,7,-38,10,-32, -59,26,-5,-7,0,30,-46,-94, -13,-9,-53,-36,-119,-97,-127,-70, 
  /* [7][0][][] */ 7,-127,-65,-84,-11,114,-75,27, -14,-124,-71,-121,33,-63,-83,-36, -7,-50,-47,-101,1,-2,-14,27, 
  /* [8][0][][] */ -103,-43,-11,-6,-29,14,-29,32, -127,-76,-28,-16,24,-45,-105,4, -90,-98,-29,-3,-43,-81,-48,-15, 
  /* [9][0][][] */ 100,-8,-11,-24,-12,-87,-28,-90, -32,-28,28,-25,-17,-126,34,-127, 7,-43,27,-40,-15,-126,-7,-65, 
  /* [10][0][][] */ 39,-2,21,-6,-3,-55,-53,-25, 1,-30,-6,-18,-17,-83,-17,-99, -29,-40,6,-44,-57,-57,22,-127, 
  /* [11][0][][] */ 11,-59,-103,-41,-21,54,49,-6, -5,-127,-91,-126,-118,-40,-36,-87, -89,-63,-21,-42,-68,-52,-4,-42, 
  /* [12][0][][] */ 114,-26,-31,-4,-10,-43,-10,-14, -1,-20,50,-8,-8,-104,30,-55, 49,-76,-16,-41,-49,-127,-36,-28, 
  /* [13][0][][] */ -29,-84,-1,14,-13,56,-8,-127, -53,-60,-3,-6,15,-9,-10,-109, -19,-11,-4,7,-5,41,-8,16, 
  /* [14][0][][] */ 8,-12,12,-39,-14,-99,1,-18, -9,-29,-4,-45,-20,-127,13,-39, -106,-5,11,-36,-8,-95,2,-26, 
  /* [15][0][][] */ -43,-62,-24,-18,-18,-107,14,-14, -47,-18,-45,-33,75,42,12,-100, 39,26,-16,-39,-8,-52,-127,-12, 
};
const TfArray<4, int> tensor_dimension7 = { 4, { 16,1,3,8 } };
const TfArray<16, float> quant7_scale = { 16, { 0.026518978178501129, 0.019905904307961464, 0.020752629265189171, 0.015079094097018242, 0.014558014459908009, 0.028313545510172844, 0.022408733144402504, 0.01751197874546051, 0.024231549352407455, 0.020066214725375175, 0.033230189234018326, 0.013569828122854233, 0.015754926949739456, 0.031628984957933426, 0.049525301903486252, 0.011771570891141891, } };
const TfArray<16, int> quant7_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(8) int32_t tensor_data8[4] = { 1, 1, 99, 65, };
const TfArray<1, int> tensor_dimension8 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data9[4] = { 1, 99, 1, 8, };
const TfArray<1, int> tensor_dimension9 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data10[4] = { 1, 1, 50, 8, };
const TfArray<1, int> tensor_dimension10 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data11[4] = { 1, 50, 1, 16, };
const TfArray<1, int> tensor_dimension11 = { 1, { 4 } };
const TfArray<4, int> tensor_dimension12 = { 4, { 1,1,99,65 } };
const TfArray<1, float> quant12_scale = { 1, { 0.0039215688593685627, } };
const TfArray<1, int> quant12_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant12 = { (TfLiteFloatArray*)&quant12_scale, (TfLiteIntArray*)&quant12_zero, 0 };
const TfArray<4, int> tensor_dimension13 = { 4, { 1,1,99,8 } };
const TfArray<1, float> quant13_scale = { 1, { 0.062053646892309189, } };
const TfArray<1, int> quant13_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant13 = { (TfLiteFloatArray*)&quant13_scale, (TfLiteIntArray*)&quant13_zero, 0 };
const TfArray<4, int> tensor_dimension14 = { 4, { 1,99,1,8 } };
const TfArray<1, float> quant14_scale = { 1, { 0.062053646892309189, } };
const TfArray<1, int> quant14_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant14 = { (TfLiteFloatArray*)&quant14_scale, (TfLiteIntArray*)&quant14_zero, 0 };
const TfArray<4, int> tensor_dimension15 = { 4, { 1,50,1,8 } };
const TfArray<1, float> quant15_scale = { 1, { 0.062053646892309189, } };
const TfArray<1, int> quant15_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant15 = { (TfLiteFloatArray*)&quant15_scale, (TfLiteIntArray*)&quant15_zero, 0 };
const TfArray<4, int> tensor_dimension16 = { 4, { 1,1,50,8 } };
const TfArray<1, float> quant16_scale = { 1, { 0.062053646892309189, } };
const TfArray<1, int> quant16_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant16 = { (TfLiteFloatArray*)&quant16_scale, (TfLiteIntArray*)&quant16_zero, 0 };
const TfArray<4, int> tensor_dimension17 = { 4, { 1,1,50,16 } };
const TfArray<1, float> quant17_scale = { 1, { 0.020195817574858665, } };
const TfArray<1, int> quant17_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant17 = { (TfLiteFloatArray*)&quant17_scale, (TfLiteIntArray*)&quant17_zero, 0 };
const TfArray<4, int> tensor_dimension18 = { 4, { 1,50,1,16 } };
const TfArray<1, float> quant18_scale = { 1, { 0.020195817574858665, } };
const TfArray<1, int> quant18_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant18 = { (TfLiteFloatArray*)&quant18_scale, (TfLiteIntArray*)&quant18_zero, 0 };
const TfArray<4, int> tensor_dimension19 = { 4, { 1,25,1,16 } };
const TfArray<1, float> quant19_scale = { 1, { 0.020195817574858665, } };
const TfArray<1, int> quant19_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant19 = { (TfLiteFloatArray*)&quant19_scale, (TfLiteIntArray*)&quant19_zero, 0 };
const TfArray<2, int> tensor_dimension20 = { 2, { 1,400 } };
const TfArray<1, float> quant20_scale = { 1, { 0.020195817574858665, } };
const TfArray<1, int> quant20_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant20 = { (TfLiteFloatArray*)&quant20_scale, (TfLiteIntArray*)&quant20_zero, 0 };
const TfArray<2, int> tensor_dimension21 = { 2, { 1,2 } };
const TfArray<1, float> quant21_scale = { 1, { 0.17741313576698303, } };
const TfArray<1, int> quant21_zero = { 1, { -5 } };
const TfLiteAffineQuantization quant21 = { (TfLiteFloatArray*)&quant21_scale, (TfLiteIntArray*)&quant21_zero, 0 };
const TfArray<2, int> tensor_dimension22 = { 2, { 1,2 } };
const TfArray<1, float> quant22_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant22_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant22 = { (TfLiteFloatArray*)&quant22_scale, (TfLiteIntArray*)&quant22_zero, 0 };
const TfLiteReshapeParams opdata0 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs0 = { 2, { 0,8 } };
const TfArray<1, int> outputs0 = { 1, { 12 } };
const TfLiteConvParams opdata1 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs1 = { 3, { 12,6,2 } };
const TfArray<1, int> outputs1 = { 1, { 13 } };
const TfLiteReshapeParams opdata2 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs2 = { 2, { 13,9 } };
const TfArray<1, int> outputs2 = { 1, { 14 } };
const TfLitePoolParams opdata3 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs3 = { 1, { 14 } };
const TfArray<1, int> outputs3 = { 1, { 15 } };
const TfLiteReshapeParams opdata4 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs4 = { 2, { 15,10 } };
const TfArray<1, int> outputs4 = { 1, { 16 } };
const TfLiteConvParams opdata5 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs5 = { 3, { 16,7,3 } };
const TfArray<1, int> outputs5 = { 1, { 17 } };
const TfLiteReshapeParams opdata6 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs6 = { 2, { 17,11 } };
const TfArray<1, int> outputs6 = { 1, { 18 } };
const TfLitePoolParams opdata7 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs7 = { 1, { 18 } };
const TfArray<1, int> outputs7 = { 1, { 19 } };
const TfLiteReshapeParams opdata8 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs8 = { 2, { 19,1 } };
const TfArray<1, int> outputs8 = { 1, { 20 } };
const TfLiteFullyConnectedParams opdata9 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs9 = { 3, { 20,5,4 } };
const TfArray<1, int> outputs9 = { 1, { 21 } };
const TfLiteSoftmaxParams opdata10 = { 1 };
const TfArray<1, int> inputs10 = { 1, { 21 } };
const TfArray<1, int> outputs10 = { 1, { 22 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6448, (TfLiteIntArray*)&tensor_dimension0, 6435, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 8, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant2))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant3))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 8, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant4))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant5))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 1560, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data9, (TfLiteIntArray*)&tensor_dimension9, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data10, (TfLiteIntArray*)&tensor_dimension10, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data11, (TfLiteIntArray*)&tensor_dimension11, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension12, 6435, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant12))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6448, (TfLiteIntArray*)&tensor_dimension13, 792, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant13))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension14, 792, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant14))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension15, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant15))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension16, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant16))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension17, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant17))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension18, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant18))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 800, (TfLiteIntArray*)&tensor_dimension19, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant19))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension20, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant20))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 400, (TfLiteIntArray*)&tensor_dimension21, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant21))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension22, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant22))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs5, (TfLiteIntArray*)&outputs5, const_cast<void*>(static_cast<const void*>(&opdata5)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs6, (TfLiteIntArray*)&outputs6, const_cast<void*>(static_cast<const void*>(&opdata6)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs7, (TfLiteIntArray*)&outputs7, const_cast<void*>(static_cast<const void*>(&opdata7)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs8, (TfLiteIntArray*)&outputs8, const_cast<void*>(static_cast<const void*>(&opdata8)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs9, (TfLiteIntArray*)&outputs9, const_cast<void*>(static_cast<const void*>(&opdata9)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs10, (TfLiteIntArray*)&outputs10, const_cast<void*>(static_cast<const void*>(&opdata10)), OP_SOFTMAX, },
};
static std::vector<void*> overflow_buffers;
static TfLiteStatus AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                                 size_t bytes, void** ptr) {
  if (current_location - bytes < tensor_boundary) {
    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    *ptr = malloc(bytes);
    if (*ptr == NULL) {
      printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return kTfLiteError;
    }
    overflow_buffers.push_back(*ptr);
    return kTfLiteOk;
  }

  current_location -= bytes;

  *ptr = current_location;
  return kTfLiteOk;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static std::vector<scratch_buffer_t> scratch_buffers;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  scratch_buffer_t b;
  b.bytes = bytes;

  TfLiteStatus s = AllocatePersistentBuffer(ctx, b.bytes, &b.ptr);
  if (s != kTfLiteOk) {
    return s;
  }

  scratch_buffers.push_back(b);

  *buffer_idx = scratch_buffers.size() - 1;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > static_cast<int>(scratch_buffers.size()) - 1) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}
} // namespace

  TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 23;
  for(size_t i = 0; i < 23; ++i) {
    tflTensors[i].type = tensorData[i].type;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
    }
    else{
       tflTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization = tensorData[i].quantization;
    if (tflTensors[i].quantization.type == kTfLiteAffineQuantization) {
      TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
      tflTensors[i].params.scale = quant->scale->data[0];
      tflTensors[i].params.zero_point = quant->zero_point->data[0];
    }
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_RESHAPE] = *tflite::ops::micro::Register_RESHAPE();
  registrations[OP_CONV_2D] = *tflite::ops::micro::Register_CONV_2D();
  registrations[OP_MAX_POOL_2D] = *tflite::ops::micro::Register_MAX_POOL_2D();
  registrations[OP_FULLY_CONNECTED] = *tflite::ops::micro::Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = *tflite::ops::micro::Register_SOFTMAX();

  for(size_t i = 0; i < 11; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
    tflNodes[i].custom_initial_data = nullptr;
    tflNodes[i].custom_initial_data_size = 0;
    if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for(size_t i = 0; i < 11; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  22, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for(size_t i = 0; i < 11; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif
  scratch_buffers.clear();
  for (size_t ix = 0; ix < overflow_buffers.size(); ix++) {
    free(overflow_buffers[ix]);
  }
  overflow_buffers.clear();
  return kTfLiteOk;
}
